from pathlib import Path

import axipy
from axipy import init_axioma, AxiomaInitLogLevel, provider_manager, LinearUnits, Feature
from osgeo import ogr
from osgeo.ogr import Geometry


def axiGeoToOgr(geo_qaxi):
    geo_ogr=ogr.CreateGeometryFromWkb(geo_qaxi.to_wkb())
    return geo_ogr
def ogrGeoToAxi(geo_ogr:Geometry,cs):
    geo_axi=axipy.Geometry.from_wkb(geo_ogr.ExportToWkb(),coordsystem=cs)
    return geo_axi

app = init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_source=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857db - Copy.gpkg"
path_dest=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1_intersectZ.tab"
definition = {'src':path_source, 'dataobject':'test_topo_3857'}
table = provider_manager.open(definition)
tab_source=provider_manager.openfile(path_source)
if Path(path_dest).exists():
    provider_manager.tab.remove_table_files(path_dest)
tab_des=provider_manager.createfile(path_dest,tab_source.schema)
fts=list(tab_source.items())
geo_1=axiGeoToOgr(fts[0].geometry)
geo_3=axiGeoToOgr(fts[2].geometry)
geo_1_3=geo_1.Difference(geo_3)
geo_1_3_union=geo_1.Union (geo_3)
geo_3_1=geo_1_3_union.Difference(geo_1_3)
geo_axi_1_3=ogrGeoToAxi(geo_1_3,tab_source.coordsystem)
geo_axi_3_1=ogrGeoToAxi(geo_3_1,tab_source.coordsystem)
ft=Feature({'ID':1},geometry=geo_axi_1_3)
tab_des.insert(ft)
ft=Feature({'ID':3},geometry=geo_axi_3_1)
tab_des.insert(ft)
tab_des.commit()
tab_source.close()
tab_des.close()
app.exit()