from pathlib import Path

import axipy
from axipy import init_axioma, AxiomaInitLogLevel, provider_manager, LinearUnits, Feature, MultiLineString
from osgeo import ogr
from osgeo.ogr import Geometry


def axiGeoToOgr(geo_qaxi):
    geo_ogr=ogr.CreateGeometryFromWkb(geo_qaxi.to_wkb())
    return geo_ogr
def ogrGeoToAxi(geo_ogr:Geometry,cs):
    geo_axi=axipy.Geometry.from_wkb(geo_ogr.ExportToWkb(),coordsystem=cs)
    return geo_axi
app = init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_source=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1.tab"
path_dest=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1_merger.tab"
tab_source=provider_manager.openfile(path_source)
if Path(path_dest).exists():
    provider_manager.tab.remove_table_files(path_dest)
tab_des=provider_manager.createfile(path_dest,tab_source.schema)
fts=list(tab_source.items())
geo_1=fts[0].geometry.to_linestring()
geo_3=fts[2].geometry.to_linestring()
geo_col=MultiLineString(cs=tab_source.coordsystem)
geo_col.append(geo_1)
geo_col.append(geo_3)
ogr_geo=axiGeoToOgr(geo_col)
ogr_symlify=ogr_geo.SimplifyPreserveTopology(1.0)
geo_axi_simlify=ogrGeoToAxi(ogr_symlify,tab_source.coordsystem)
ft=Feature({"ID":1},geometry=geo_axi_simlify)
tab_des.insert(ft)
tab_des.commit()
tab_source.close()
tab_des.close()
app.exit()

