import os
from pathlib import Path

import axipy
from axipy import init_axioma, AxiomaInitLogLevel, provider_manager, LinearUnits, Feature

from TopoSimplifier.ui.tools.add_helper.ogr_helper import createFieldDefinitions, createGpkgTab


def getNewGeo(geo_comb,cur_geo):
    temp_geo=geo_comb.difference(cur_geo)
    res_geo=geo_comb.difference(temp_geo)
    return res_geo
app = init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_source=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1.tab"
path_dest=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1_prepare.gpkg"
tab_source=provider_manager.openfile(path_source)
if Path(path_dest).exists():
    os.remove(path_dest)
fields_def,srs=createFieldDefinitions(tab_source.schema)
is_ok=createGpkgTab(path_dest,fields_def,srs)
definition = {'src':path_dest, 'dataobject':'test_topo_3857_1_prepare'}
tab_des = provider_manager.open(definition)
#tab_des=provider_manager.createfile(path_dest,tab_source.schema)
geo_comb=None
for ft in tab_source.items():
    if geo_comb is None:
        geo_comb=ft.geometry
    else:
        geo_comb=geo_comb.union(ft.geometry)
for ft in tab_source.items():
    #new_geo=getNewGeo(geo_comb,ft.geometry)
    #ft.geometry=new_geo
    tab_des.insert(ft)
#ft=Feature({"ID":0},geometry=geo_comb)
#tab_des.insert(ft)
tab_des.commit()
tab_source.close()
tab_des.close()

app.exit()
