from pathlib import Path

from axipy import init_axioma, AxiomaInitLogLevel, provider_manager, LinearUnits, Feature, GeometryCollection, Geometry
from osgeo import ogr
from osgeo.ogr import CreateGeometryFromWkb

app = init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_source=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1.tab"
path_dest=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1_intersect3.tab"
tab_source=provider_manager.openfile(path_source)
if Path(path_dest).exists():
    provider_manager.tab.remove_table_files(path_dest)
tab_des=provider_manager.createfile(path_dest,tab_source.schema)
geo_collection=GeometryCollection(cs=tab_source.coordsystem)
for ft in tab_source.items():
    geo_collection.append(ft.geometry)
geo_ogr=CreateGeometryFromWkb(geo_collection.to_wkb())
geo_simli=geo_ogr.SimplifyPreserveTopology(100)
geo_axi= Geometry.from_wkb(geo_simli.ExportToWkb(), coordsystem=tab_source.coordsystem)




tab_source.close()
ft_new=Feature({"ID":1},geometry=geo_axi)
tab_des.insert(ft_new)

tab_des.commit()
tab_des.close()
print("end")
app.exit()