import axipy
from axipy import init_axioma, AxiomaInitLogLevel, provider_manager
from osgeo import ogr
from osgeo.ogr import Geometry


def ogrGeoToAxi(geo_ogr:Geometry,cs):
    geo_axi=axipy.Geometry.from_wkb(geo_ogr.ExportToWkb(),coordsystem=cs)
    return geo_axi
class OgrSource:
    def __init__(self):
        pass
    def open(self,path_db,name_layer):
        self.__name_layer=name_layer
        self.__ds=ogr.OpenShared(path_db)
    def getSnapGeo(self,id_base,id_second,name_field):
        sql_1="select * from "+self.__name_layer+" where "+name_field+"="+str(id_base)
        sql_2 = "select * from " + self.__name_layer + " where " + name_field + "=" + str(id_second)
        sql="select  ST_Snap(f1.geom,f2.geom,1.0) as geom From ("+sql_1+") as f1,("+sql_2+") as f2"
        lyar_sel = self.__ds.ExecuteSQL(sql)
        for ft in lyar_sel:
            geometry=ft.GetGeometryRef()
            break
        lyar_sel=None
        return geometry
    def close(self):
        self.__ds.FlushCache()
        self.__ds.Close()
        self.__ds=None
app = init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_source=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1.gpkg"
definition = {'src':path_source, 'dataobject':'test_topo_3857_1'}
tab_source = provider_manager.open(definition)
cls_ogr=OgrSource()
cls_ogr.open(path_source,'test_topo_3857_1')
for ft in tab_source.items():
    if ft['fid']==3:
        ogr_geo=cls_ogr.getSnapGeo(3,2,'fid')
        geo_axi=ogrGeoToAxi(ogr_geo,tab_source.coordsystem)
        ogr_geo=None
        ft.geometry=geo_axi
        tab_source.update(ft)
cls_ogr.close()
tab_source.commit()
tab_source.close()
print("end")
app.exit()