import axipy
from axipy import init_axioma, AxiomaInitLogLevel, provider_manager, data_manager, TypeSqlDialect
from osgeo import ogr
from osgeo.ogr import Geometry


def ogrGeoToAxi(geo_ogr:Geometry,cs):
    geo_axi=axipy.Geometry.from_wkb(geo_ogr.ExportToWkb(),coordsystem=cs)
    return geo_axi
class OgrSource:
    def __init__(self):
        pass
    def open(self,path_db,name_layer):
        self.__name_layer=name_layer
        self.__ds=ogr.OpenShared(path_db)
    def getSnapGeo(self,id_base,id_second,name_field):
        sql_1="select * from "+self.__name_layer+" where "+name_field+"="+str(id_base)
        sql_2 = "select * from " + self.__name_layer + " where " + name_field + "=" + str(id_second)
        sql="select  ST_Snap(f1.geom,f2.geom,1.0) as geom From ("+sql_1+") as f1,("+sql_2+") as f2"
        lyar_sel = self.__ds.ExecuteSQL(sql)
        for ft in lyar_sel:
            geometry=ft.GetGeometryRef()
            break
        lyar_sel=None
        return geometry
    def close(self):
        self.__ds.FlushCache()
        self.__ds.Close()
        self.__ds=None
def snapGeo(name_table,id_base,id_second):
    sql_base="select fid, obj from "+name_table+" where fid="+str(id_base)
    #query_1=data_manager.query(sql_base)
    sql_second="select fid,obj from "+name_table+" where fid="+str(id_second)
    #query_2=data_manager.query(sql_second)
    #sql="Snap(FromAxiGeo("+sql_base+"),FromAxiGeo("+query_2+"),1) as obj"
    #sql = "Snap(FromAxiGeo(" +query_1.name + ".obj),FromAxiGeo(" + query_2.name + ".obj),1) "
    #sql_update="Update "+name_table+" set obj="+sql+" where fid="+str(id_base)
    #sql_update = "Update " + name_table + " set obj=" + sql + " where fid=" + str(id_base)
    sql_sel="select base.fid,Snap(FromAxiGeo(base.obj,second.obj,1) as obj From ("+sql_base+") as base ,("+sql_second+") as second"
    sql_sel = "select base.fid,Snap(FromAxiGeo(base.obj),FromAxiGeo(second.obj),1) as obj From (" + sql_base + ") as base ,(" + sql_second + ") as second where base.fid<>second.fid"
    print(sql_sel)
    query=data_manager.query(sql_sel,dialect=TypeSqlDialect.sqlite)
    fts_sel=list(query.items())
    geo_snap=fts_sel[0].geometry
    #query.close()
    return geo_snap
#app = init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
'''
path_source=r"E:\Support\AxiomaTesting\Topo\test\test_topo_3857_1.gpkg"
definition = {'src':path_source, 'dataobject':'test_topo_3857_1'}
tab_source = provider_manager.open(definition)
'''
name_tab='test_topo_3857_1'
tab_source=data_manager.find(name_tab)
for ft in tab_source.items():
    id_base=ft['fid']
    sql_intersect="select base.* From "+tab_source.name+" as base ,(select * from  "+tab_source.name+" where fid="+str(ft['fid'])+") as  item where base.fid>item.fid and base.obj  Intersects  item.obj "
    query_intersect=data_manager.query(sql_intersect)
    for ft_sel in query_intersect:
        id_second=ft_sel['fid']
        geo_new_base=snapGeo(tab_source.name,id_base,id_second)
        if geo_new_base is not None:
            ft.geometry = geo_new_base
            tab_source.update(ft)

        geo_new_second=snapGeo(tab_source.name,id_second,id_base)
        if geo_new_second is not None:
            ft_sel.geometry=geo_new_second
            query_intersect.update(ft_sel)

    query_intersect.close()
    '''
    if ft['fid']==3:
        #ogr_geo=cls_ogr.getSnapGeo(3,2,'fid')
        #geo_axi=ogrGeoToAxi(ogr_geo,tab_source.coordsystem)
        geo_snap=snapGeo(tab_source.name,3,2)
        #ogr_geo=None
        ft.geometry=geo_snap
        tab_source.update(ft)
    '''
#tab_source.commit()
#tab_source.close()
print("end")
#app.exit()