import os

import axipy
from axipy import Plugin, Position

from TopoSimplifier.ui.mainDlg import TopoSimplifier
from TopoSimplifier.ui.tools.add_helper.observer import factoryObserver


class SimplifyTopologyPolygons(Plugin):
    def __init__(self) -> None:
        self.__name_observer_tab="PolygonTable"
        self.__observer=factoryObserver(self.__name_observer_tab)

        self._title = self.tr("Упрощение полигонов с сохранением топологии")
        local_file_icon = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'simplify_polygon.png')
        self.__action_Simplify = self.create_action(self._title,
                                               icon=local_file_icon, on_click=self. run_simplify,
                                               enable_on=self.__name_observer_tab)
        position = Position('Дополнительно', 'Действие')
        position.add(self.__action_Simplify)
    def run_simplify(self):
        cls_dlg = TopoSimplifier(axipy.app.mainwindow.qt_object())
        cls_dlg.exec_()
