import axipy
from axipy import Rect, Line, Pnt, LinearUnit


class Distance:
    def __init__(self,value,unit:axipy.LinearUnit):
        self.__value=value
        self.__unit=unit

    @property
    def value(self):
        return self.__value

    @value.setter
    def value(self, value):
        self.__value = value
    @property
    def unit(self):
        return self.__unit
    @unit.setter
    def unit(self,value):
        self.__unit=value
    def to_unit(self,unit):
        return Distance(self.__unit.to_unit(unit,self.__value),unit)

def getToleranceFromGrad(bound:Rect,cs,dist:Distance):
    geo_line_width=Line(Pnt(bound.xmin,bound.center.y),Pnt(bound.xmax,bound.center.y),cs=cs)
    geo_line_height = Line(Pnt(bound.center.x, bound.ymin), Pnt(bound.center.x, bound.ymax), cs=cs)
    length_width=geo_line_width.get_length(dist.unit)
    length_height = geo_line_height.get_length(dist.unit)
    w=bound.width/length_width
    h=bound.height/length_height
    midl_value=(w+h)/2
    return midl_value*dist.value


