import axipy
from axipy import Geometry, MultiLineString, LineString, GeometryCollection, data_manager, Polygon, MultiPolygon, Unit
from loguru import logger
from osgeo import ogr


def combineLineString(geo_0,geo_1):
    poly_1 = list(geo_0.points)
    poly_2 = list(geo_1.points)
    if poly_1[0] == poly_2[-1]:
        ''' '''
        poly_1.pop(0)
        poly_2.extend(poly_1)
        return LineString(poly_2, geo_0.coordsystem)
    if poly_1[-1]==poly_2[0]:
        jkl=0
        poly_2.pop(0)
        poly_1.extend(poly_2)
        return LineString(poly_1, geo_0.coordsystem)

    return None
def prepareMultiLineString(geo):
    ''' пока для двух'''
    count=len(geo)
    if count>2:
        data_multiLineString=[]
        base_line_string=geo[0]
        for i in range(1,count):
            pnts=list(base_line_string.points)

            if pnts[0]==pnts[-1]:
                ''' полигон '''
                data_multiLineString.append(geo[i-1].to_polygon())
                base_line_string=geo[i]
                continue
            tem_obj=combineLineString(base_line_string,geo[i])
            if tem_obj is None:
                data_multiLineString.append(base_line_string)
                base_line_string=geo[i]
                continue
            base_line_string=tem_obj
        if len(data_multiLineString)>0:
            data_multiLineString.append(base_line_string)
            poly_collection=GeometryCollection(cs=geo.coordsystem)
            for item in data_multiLineString:
                poly_collection.append(item)
            return poly_collection
        return base_line_string
    poly_1=list(geo[0].points)
    poly_2=list(geo[1].points)
    if poly_1[0]==poly_2[-1]:
        ''' '''
        poly_1.pop(0)
        poly_2.extend(poly_1)
        return LineString(poly_2,geo.coordsystem)
    if poly_1[-1]==poly_2[0]:
        jkl=0
        poly_2.pop(0)
        poly_1.extend(poly_2)
        return LineString(poly_1, geo.coordsystem)
    return geo
def MultiLineStringToLineString(geo):
    lines_col=[]
    count=len(geo)
    poly_start=geo[0]
    end_point=list(poly_start.points)[-1]
    out_points=[]
    out_points.extend(list(poly_start.points))
    for i in range(1,count):
        poly_next=geo[i]
        points=list(poly_next.points)
        if end_point==points[0]:
            out_points.extend(points[1:])
            end_point= points[-1]
        else:
            lines_col.append(out_points)
            out_points=[]
            out_points.extend(points)
            end_point = points[-1]
            jkl=0
    if len(lines_col)>0:
        if len(out_points)>0:
            lines_col.append(out_points)
            msl = MultiLineString()
            msl.coordsystem=geo.coordsystem
            for poly in lines_col:
                polyline=LineString(poly,geo.coordsystem)
                msl.append(polyline)
            msl=prepareMultiLineString(msl)
            return msl
    return LineString(out_points,geo.coordsystem)
def getEdge(tab_base,id_base,name_field_id,geometry_base:Geometry):
    rect_geo=geometry_base.bounds
    list_intersection=[]
    for ft in tab_base.itemsInRect(rect_geo):
        if ft[name_field_id]<=id_base:
            continue

        geo_intersect=geometry_base.intersection(ft.geometry)
        if geo_intersect is None:
            continue
        ogr_geoemtry= ogr.CreateGeometryFromWkb(geo_intersect.to_wkb())
        ogr_new_geometry=ogr.ForceToLineString(ogr_geoemtry)
        ogr_geoemtry=None
        if ogr_new_geometry is not None:
            geo_axi=Geometry.from_wkb(ogr_new_geometry.ExportToWkb(),coordsystem=geo_intersect.coordsystem)
            #geo_axi = Geometry.from_wkb(ogr_new_geometry.ExportToWkb())
            ogr_new_geometry=None
            if geo_axi is not None:
                geo_intersect=geo_axi
        #test_geometry=geo_intersect.try_to_simplified()

        if isinstance(geo_intersect,MultiLineString):
            geo_intersect=MultiLineStringToLineString(geo_intersect)
        list_intersection.append({'id_base':id_base,'id':ft[name_field_id],'geometry':geo_intersect})
    if len(list_intersection)==0:
        return None
    return list_intersection
def getEdgeExternal(tab_base,id_base,name_field_id,geometry_base:Geometry,fun_collback):
    list_intersection = []
    for i,ft in enumerate(tab_base.items()):
        isCancel=fun_collback(i)
        if isCancel:
            return None
        geo_curent=ft.geometry.to_linestring()
        if geo_curent is None:
            continue
        #if not geometry_base.crosses(geo_curent):
        #    continue
        #if geometry_base.contains(ft.geometry):
        #    continue
        geo_intersect = geometry_base.intersection(geo_curent)
        if geo_intersect is None:
            continue
        ogr_geoemtry = ogr.CreateGeometryFromWkb(geo_intersect.to_wkb())
        ogr_new_geometry = ogr.ForceToLineString(ogr_geoemtry)
        ogr_geoemtry = None
        if ogr_new_geometry is not None:
            geo_axi = Geometry.from_wkb(ogr_new_geometry.ExportToWkb(), coordsystem=geo_intersect.coordsystem)
            # geo_axi = Geometry.from_wkb(ogr_new_geometry.ExportToWkb())
            ogr_new_geometry = None
            if geo_axi is not None:
                geo_intersect = geo_axi
        # test_geometry=geo_intersect.try_to_simplified()

        if isinstance(geo_intersect, MultiLineString):
            geo_intersect = MultiLineStringToLineString(geo_intersect)
        list_intersection.append({'id_base': ft[name_field_id], 'id':id_base, 'geometry': geo_intersect})
    if len(list_intersection) == 0:
        return None
    return list_intersection
def combinePolygon(poly_1,area_1,poly_2,area_2):
    if area_2>=area_1:
        if poly_2.contains(poly_1):
            return poly_2.difference(poly_1)
        else:
            return poly_2.union(poly_1)
    else:
        if poly_1.contains(poly_2):
            return poly_1.difference(poly_2)
        else:
            return poly_2.union(poly_1)
    return None

def combinePolygons(base_polygons,polygon_2):
    area_base=base_polygons.get_area(Unit.sq_m)
    if isinstance(polygon_2,Polygon):
        area_2=polygon_2.get_area(Unit.sq_m)
        result_poly=combinePolygon(base_polygons,area_base,polygon_2,area_2)
        return result_poly
    result_polygon=MultiPolygon(cs=base_polygons.coordsystem)
    if isinstance(base_polygons,Polygon):
        result_polygon.append(base_polygons)
    else:
        result_polygon=base_polygons.clone()
    for poly in polygon_2:
        area_2=poly.get_area(Unit.sq_m)
        area_base=result_polygon.get_area(Unit.sq_m)
        temp_poly=combinePolygon(result_polygon,area_base,poly,area_2)
        if temp_poly is not None:
            result_polygon=temp_poly
    return result_polygon

def createObject(desc_id:dict,tab,name_field_row_id):
    name_field=desc_id['name']
    value=desc_id['value']
    print(value)
    second_name=desc_id['second']
    sql="select RowNum() as "+name_field_row_id+",* from "+tab.name+" where "+name_field+"="+str(value)+" or "+second_name+"="+str(value)
    query=data_manager.query_hidden(sql)
    geo_comb=MultiLineString(cs=tab.coordsystem)
    poligins_=[]

    for ft in query.items():

        if not isinstance(ft.geometry,LineString) :
            if isinstance(ft.geometry,axipy.Point):
                continue
            linestrings,polygons=prepraeCollection(ft.geometry)
            if len(linestrings)>0:
                for item in linestrings:
                    geo_comb.append(item)
            poligins_.extend(polygons)
            #geo_comb=None
            continue
        geo_comb.append(ft.geometry)
    geo_multi_polygon=None
    if len(poligins_)>0:
        geo_multi_polygon=listPolygonsToMultiPolygons(poligins_)
    if geo_comb is None or len(geo_comb)==0:
        query.close()
        if geo_multi_polygon is not None:
            return geo_multi_polygon
        return None
    if geo_multi_polygon is not None:
        geo_comb_poly=geo_comb.to_polygon()
        if geo_comb_poly is not None:
            #geo_multi_polygon.append(geo_comb_poly)
            if geo_multi_polygon.coordsystem is None:
                geo_multi_polygon.coordsystem=tab.coordsystem
            if geo_comb_poly.coordsystem is None:
                geo_comb_poly.coordsystem=tab.coordsystem
            #geo_multi_polygon=combinePolygons(geo_multi_polygon,geo_comb_poly)
            geo_multi_polygon = combinePolygons(geo_comb_poly,geo_multi_polygon)
        else:
            geo_ogr=ogr.CreateGeometryFromWkb(geo_comb.to_wkb())
            if geo_ogr is not None:
                geo_ogr_line_string=ogr.ForceToLineString(geo_ogr)
                geo_ogr=None
                if geo_ogr_line_string is not None:
                    geo_axi=Geometry.from_wkb(geo_ogr_line_string.ExportToWkb(),coordsystem=geo_comb.coordsystem)
                    geo_ogr_line_string=None
                    if geo_axi is not None:
                        try:
                            geo_multi_polygon.append(geo_axi)
                        except Exception as e:
                            query.close()
                            logger.exception(e)
                            return None
        query.close()
        return geo_multi_polygon
    query.close()
    return geo_comb.to_polygon()
def prepraeCollection(geo_collection):
    linestring=[]
    poligons=[]
    for geo in geo_collection:
        if isinstance(geo,LineString):
            points=list(geo.points)
            if points[0]==points[-1]:
                ''' polygon'''
                polygon=Polygon(pntsToTuples(points),cs=geo_collection.coordsystem)
                poligons.append(polygon)
                continue

            linestring.append(geo)
        if isinstance(geo,Polygon):
            if geo.coordsystem is None:
                geo.coordsystem=geo_collection.coordsystem
            poligons.append(geo)
    return linestring,poligons
def pntsToTuples(points):
    list_tp=[]
    for pnt in points:
        list_tp.append((pnt.x,pnt.y))
    return list_tp
def listPolygonsToMultiPolygons(poligons):
    if len(poligons)==0:
        return None
    geo_multipolygon=MultiPolygon(cs=poligons[0].coordsystem)
    for poly in poligons:
        geo_multipolygon.append(poly)
    return geo_multipolygon