from axipy import ObserverManager, data_manager, GeometryClass, Observer


def factoryObserver(name_observer)->Observer:
    observer = None
    try:
        observer = ObserverManager.get(name_observer)
    except:
        pass
    if observer is None:
        observer = ObserverManager.create(name_observer, False)
    def openTable(name_table):
        if observer.value:
            return
        tab_open=data_manager.find(name_table)
        if tab_open is None:
            return
        if GeometryClass.Polygons in tab_open.class_geometries():
            observer.value=True
            return
        return

    def closeTable(name_table):
        if not observer.value:
            return
        if len(data_manager.tables)==0:
            observer.value = False
            return
        for tab in data_manager.tables:
            if tab.name==name_table:
                continue
            if GeometryClass.Polygons in tab.class_geometries():
                return
        observer.value = False
        return

    setattr(observer, "openTable", openTable)
    setattr(observer, "closeTable", closeTable)
    data_manager.added.connect(openTable)
    data_manager.removed.connect(closeTable)

    return observer