import os
from pathlib import Path

from axipy import Schema, Attribute
from osgeo import ogr
from osgeo.osr import SpatialReference


def createGpkgTab(path_out:str,fields_def,srs):
    out_path=Path(path_out)
    if out_path.exists():
        os.remove(path_out)
    drive=ogr.GetDriverByName("GPKG")
    ds=drive.CreateDataSource(path_out)
    name_tab=out_path.stem
    layer = ds.CreateLayer(name_tab, srs, geom_type=ogr.wkbUnknown)
    for field in fields_def:

        layer.CreateField(field)
    layer=None
    ds.FlushCache()
    ds=None
    return True
def createFieldDefinitions(schema:Schema):
    ogr_field_defs=[]
    for att in schema:
        ogr_field=None
        if att.type_string=='int':
            ogr_field=ogr.FieldDefn(att.name,ogr.OFTInteger)

        if att.type_string=='double' or att.type_string=='float':
            ogr_field=ogr.FieldDefn(att.name,ogr.OFTReal)
        if att.type_string=='string':
            ogr_field = ogr.FieldDefn(att.name, ogr.OFTString)
            ogr_field.SetWidth(att.length)
        if ogr_field is not None:
            ogr_field_defs.append(ogr_field)
        else:
            jkl=0
    srs_wkt=schema.coordsystem.wkt
    srs=SpatialReference()
    srs.ImportFromWkt(srs_wkt)
    return ogr_field_defs,srs